Subject: Re: [RFC PATCH 07/11] IB/Verbs: Use management helper has_mcast() and, cap_mcast() for mcast-check

From: Michael Wang <[email-masked]>
Date: Mon, 30 Mar 2015 10:30:36 +0200

On 03/27/2015 06:47 PM, Jason Gunthorpe wrote:
> On Fri, Mar 27, 2015 at 01:05:08PM -0400, ira.weiny wrote:
>
>>> But it seems redudent, since mcast_add_one will already not add a port that is
>>> not IB, so mcast_event_handler is not callable. Something to do with
>>> rocee/ib switching?
>> I'm not sure about this either.  This check seems to be necessary only on a
>> per-port level.  It does seem apparent that one can't go from Eth to IB.  What
>> happens if you go from IB to Eth on the port?
> Hmm... I see a mlx4_change_port_types which ultimately calls
> ib_unregister_device, which suggests the port type doesn't change at
> runtime (yay)
Yeah, seems like mlx4 will reinitialize the device when port link layer
changed.

I've take a look at other HW, they directly return a static type or
infer from transport type (I suppose this won't change dynamically).

Thus I also agreed check inside mcast_event_handler() is unnecessary,
maybe we can change that logical to WARN_ON(!cap_mcast()) ?

Regards,
Michael Wang

>
> So maybe these checks really are redundant?
>
> Jason

--
To unsubscribe from this list: send the line "unsubscribe linux-rdma" in
the body of a message to [email-masked]
More majordomo info at  http://vger.kernel.org/majordomo-info.html